#include <bits/stdc++.h>
using namespace std;

using ll = long long;

ll x[1005], y[1005], r[1005];
vector<int> edges[1005];
int c[1005];

pair<bool, int> dfs(int v, int z) {
    bool ok = true;
    int res = z ? 1 : -1;
    for (int u : edges[v]) {
        if (c[u] == -1) {
            c[u] = z ^ 1;
            auto [a, b] = dfs(u, z ^ 1);
            ok = ok && a;
            res += b;
        }
        else if (z == c[u]) ok = false;
    }
    return {ok, res};
}

int main() {
    int n;
    scanf("%d", &n);
    for (int i=0; i<n; i++) scanf("%lld%lld%lld", &x[i], &y[i], &r[i]);
    for (int i=0; i<n; i++) {
        c[i] = -1;
        for (int j=0; j<n; j++) {
            if ((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]) == (r[i] + r[j]) * (r[i] + r[j])) {
                edges[i].push_back(j);
                //printf("Edge %d %d\n", i, j);
            }
        }
    }
    bool ok = false;
    for (int i=0; i<n; i++) {
        if (c[i] == -1) {
            c[i] = 0;
            auto [a, b] = dfs(i, 0);
            //printf("Test %d %d\n", a ? 1 : 0, b);
            if (a && b) ok = true;
        }
    }
    printf(ok ? "YES\n" : "NO\n");
}